/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package edu.umn.d.cs5541.chasemaze;

import java.util.Random;

/**
 *
 * @author rmaclin
 */
class Maze {

    public static final double REWARD_FOUND_GOAL = 100;
    public static final double REWARD_CAUGHT = -100;
    public static final double REWARD_TIME_EXPIRED = 0;
    public static final double REWARD_OTHER = -1;

    public static final int MAX_STEPS = 50;

    public static final int MIN_ACTION = 0;
    public static final int MAX_ACTION = 4;
    public static final int ACTION_NONE = 0;
    public static final int ACTION_LEFT = 1;
    public static final int ACTION_RIGHT = 2;
    public static final int ACTION_UP = 3;
    public static final int ACTION_DOWN = 4;

    Random rand_num_gen;

    int[][] maze_obstacles;
    static final int GOAL_X = 6;
    static final int GOAL_Y = 6;

    Point player;
    Point opponent;
    Point goal;

    int num_steps;

    int make_player_move(int action) {
        switch (action) {
            case ACTION_NONE: break;
            case ACTION_LEFT:
                if (maze_obstacles[player.x-1][player.y] == 0)
                    player.x = player.x - 1;
                break;
            case ACTION_RIGHT:
                if (maze_obstacles[player.x+1][player.y] == 0)
                    player.x = player.x + 1;
                break;
            case ACTION_UP:
                if (maze_obstacles[player.x][player.y - 1] == 0)
                    player.y = player.y - 1;
                break;
            case ACTION_DOWN:
                if (maze_obstacles[player.x][player.y+1] == 0)
                    player.y = player.y + 1;
                break;
            default:
                System.out.println("Unknown action");
                break;
        }
        if ((player.x == GOAL_X) && (player.y == GOAL_Y))
            return 1;
        if ((player.x == opponent.x) && (player.y == opponent.y))
            return -1;
        return 0;
    }

    int opponent_move() {
        int best_action = ACTION_NONE;
        double best_dist = ((player.x - opponent.x) * (player.x - opponent.x)) + ((player.y - opponent.y) * (player.y - opponent.y));
        double the_dist;
        if (maze_obstacles[opponent.x-1][opponent.y] == 0) {
            the_dist = ((player.x - (opponent.x-1)) * (player.x - (opponent.x-1))) + ((player.y - opponent.y) * (player.y - opponent.y));
            if (the_dist < best_dist) {
                best_action = ACTION_LEFT;
                best_dist = the_dist;
            }
        }
        if (maze_obstacles[opponent.x+1][opponent.y] == 0) {
            the_dist = ((player.x - (opponent.x+1)) * (player.x - (opponent.x+1))) + ((player.y - opponent.y) * (player.y - opponent.y));
            if (the_dist < best_dist) {
                best_action = ACTION_RIGHT;
                best_dist = the_dist;
            }
        }
        if (maze_obstacles[opponent.x][opponent.y-1] == 0) {
            the_dist = ((player.x - opponent.x) * (player.x - opponent.x)) + ((player.y - (opponent.y-1)) * (player.y - (opponent.y-1)));
            if (the_dist < best_dist) {
                best_action = ACTION_UP;
                best_dist = the_dist;
            }
        }
        if (maze_obstacles[opponent.x][opponent.y+1] == 0) {
            the_dist = ((player.x - opponent.x) * (player.x - opponent.x)) + ((player.y - (opponent.y+1)) * (player.y - (opponent.y+1)));
            if (the_dist < best_dist) {
                best_action = ACTION_DOWN;
                best_dist = the_dist;
            }
        }
        switch (best_action) {
            case ACTION_NONE: break;
            case ACTION_LEFT: opponent.x = opponent.x - 1; break;
            case ACTION_RIGHT: opponent.x = opponent.x + 1; break;
            case ACTION_UP: opponent.y = opponent.y - 1; break;
            case ACTION_DOWN: opponent.y = opponent.y + 1; break;
        }
        if (best_dist == 0.0)
            return 1;
        return 0;
    }

    public void Maze() {
    }

    public void setup () {
        rand_num_gen = new Random();
        maze_obstacles = new int[8][8];
        for (int x = 1; x <= 7; x++)
            for (int y = 1; y <= 7; y++)
                maze_obstacles[x][y] = 1;
        for (int x = 2; x <= 6; x++)
            for (int y = 2; y <= 6; y++)
                maze_obstacles[x][y] = 0;
        maze_obstacles[4][4] = 1;
        maze_obstacles[3][4] = 1;
        maze_obstacles[4][3] = 1;
        maze_obstacles[5][4] = 1;
        maze_obstacles[4][5] = 1;
    }

    public void initialize() {
        player = new Point();
        opponent = new Point();
        num_steps = 1;
        do {
            player.x = rand_num_gen.nextInt(5) + 2;
            player.y = rand_num_gen.nextInt(5) + 2;
        } while ((maze_obstacles[player.x][player.y] == 1) || ((player.x == GOAL_X) && (player.y == GOAL_Y)));
        do {
            opponent.x = rand_num_gen.nextInt(5) + 2;
            opponent.y = rand_num_gen.nextInt(5) + 2;
        } while ((maze_obstacles[opponent.x][opponent.y] == 1) || ((player.x == opponent.x) && (player.y == opponent.y)));
    }

    public void current_locations(Point p, Point o) {
        p.x = player.x;
        p.y = player.y;
        o.x = opponent.x;
        o.y = opponent.y;
    }

    public double execute_action(int action) {
        int move_result = make_player_move(action);
        if (move_result == 1)
            return REWARD_FOUND_GOAL;
        else if (move_result == -1)
            return REWARD_CAUGHT;
        num_steps = num_steps + 1;
        if (opponent_move() == 1)
            return REWARD_CAUGHT;
        if (num_steps >= MAX_STEPS)
            return REWARD_TIME_EXPIRED;
        return REWARD_OTHER;
    }

    public void show_maze() {
        for (int y = 1; y <= 7; y++) {
            for (int x = 1; x <= 7; x++)
                if (maze_obstacles[x][y] == 1)
                    System.out.print("X");
                else if ((x == player.x) && (y == player.y))
                    System.out.print("P");
                else if ((x == opponent.x) && (y == opponent.y))
                    System.out.print("O");
                else if ((x == GOAL_X) && (y == GOAL_Y))
                    System.out.print("G");
                else
                    System.out.print(" ");
            System.out.println("");
        }
    }
}
